package edu.kit.ipd.descartes.adaptation.evaluation.weightingfunction;

import static org.junit.Assert.*;

import org.eclipse.emf.common.util.URI;
import org.junit.Before;
import org.junit.Test;

import edu.kit.ipd.descartes.adaptation.AbstractTest;
import edu.kit.ipd.descartes.adaptation.AdaptationControl;
import edu.kit.ipd.descartes.adaptation.model.dmm.AdaptationProcessModelLoader;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess;
import edu.kit.ipd.descartes.mm.adaptation.Strategy;
import edu.kit.ipd.descartes.mm.adaptation.WeightingFunction;

public class ResourceEfficiencyTest extends AbstractTest {
    
    IWeightingFunction resEfficiency = null;
    Strategy testStrategy = null;

    @Before
    public void setUp() throws Exception {
        super.setUp();
        
        String propertiesFile = "default.properties";
        AdaptationControl control = new AdaptationControl();
        control.init(propertiesFile);
        
        URI uri = URI.createFileURI("/Users/nhuber/Documents/workspace/descartes/metamodel/edu.kit.ipd.descartes.adaptation.test/test_models/StaRepository.xmi");
        AdaptationProcessModelLoader loader = AdaptationProcessModelLoader.getInstance();
        AdaptationProcess process = loader.load(uri);
        testStrategy = process.getStrategies().get(1);
    }

    @Test
    public void testCalculateWeight() {
        WeightingFunction function = testStrategy.getWeightingFunction();
        resEfficiency = new ResourceEfficiency();
        resEfficiency.setWeightingFunction(function);
        assertEquals(-1, resEfficiency.calculateWeight(testStrategy.getTacticWithHighestWeight()), 0.01);
    }

}
