package edu.kit.ipd.descartes.adaptation.model.dmm;

import static org.junit.Assert.*;

import org.eclipse.emf.common.util.URI;
import org.junit.Before;
import org.junit.Test;

import edu.kit.ipd.descartes.adaptation.AbstractTest;
import edu.kit.ipd.descartes.adaptation.AdaptationControl;
import edu.kit.ipd.descartes.adaptation.model.dmm.AdaptationProcessModelLoader;
import edu.kit.ipd.descartes.mm.adaptation.AdaptationProcess;
import edu.kit.ipd.descartes.mm.resourcelandscape.DistributedDataCenter;

public class AdaptationProcessModelLoaderTest extends AbstractTest {

    @Before
    public void setUp() throws Exception {
        super.setUp();
        String propertiesFile = "default.properties";
        AdaptationControl control = new AdaptationControl();
        control.init(propertiesFile);
    }

    @Test
    public void testGetDistributedDataCenter() {
        DistributedDataCenter ddc = AdaptationProcessModelLoader.getDistributedDataCenter();
        assertTrue(!ddc.equals(null));
        assertTrue(ddc.getConsistsOf().size() > 0);
    }
    
    @Test
    public void testLoad() {
        AdaptationProcessModelLoader loader = AdaptationProcessModelLoader.getInstance();
        String modelFile = "/Users/nhuber/Documents/workspace/descartes/metamodel/Examples/SEAMS_Case_Study/pushpull.adaptation";
        AdaptationProcess process = loader.load(URI.createFileURI(modelFile));
    }
    
    @Test
    public void testGetModelLocation() {
        AdaptationProcessModelLoader loader = AdaptationProcessModelLoader.getInstance();
        URI modelUri = URI.createFileURI("/Users/nhuber/Documents/workspace/descartes/metamodel/Examples/SEAMS_Case_Study/pushpull.adaptation");
        AdaptationProcess process = loader.load(modelUri);
        assertEquals(modelUri, loader.getCurrentModelUri());
    }

}
