package edu.kit.ipd.descartes.adaptation.model.perfdatarepo;

import static org.junit.Assert.assertTrue;

import org.junit.Before;
import org.junit.Test;

import edu.kit.ipd.descartes.adaptation.AbstractTest;

public class PerformanceDataRepositoryHandlerFactoryTest extends AbstractTest {

    private static final String PERFORMANCE_DATA_REPOSITORY_CLASSNAME = "edu.kit.ipd.descartes.perfdatarepo.PerformanceDataRepository";
    private static final String OBSERVATION_REPOSITORY_CLASSNAME = "edu.kit.ipd.descartes.ql.models.repository.ObservationRepository";

    @Before
    public void setUp() throws Exception {
        super.setUp();
    }

    @Test
    public void testCreatePerformanceDataRepositoryHandler() {
        IPerformanceDataRepositoryHandler handler;
        
        handler = PerformanceDataRepositoryHandlerFactory.createHandler(PERFORMANCE_DATA_REPOSITORY_CLASSNAME);
        assertTrue(handler instanceof PerformanceDataRepositoryHandler);
        
        handler = PerformanceDataRepositoryHandlerFactory.createHandler(OBSERVATION_REPOSITORY_CLASSNAME);
        assertTrue(handler instanceof ObservationRepositoryHandler);
    }
    
    @Test
    public void testCreatePerformanceDataRepositoryHandlerException() {
        IPerformanceDataRepositoryHandler handler;
        handler = PerformanceDataRepositoryHandlerFactory.createHandler("");
        assertTrue(handler == null);
        
        handler = PerformanceDataRepositoryHandlerFactory.createHandler("xyz");
        assertTrue(handler == null);
    }

}
